// a[i][j] = nr minim de orase dintr-un judet a.i. sa am j orase care nu-s inca fixe
//           intr-un judet; pentru orasele din subarb lui i
// b[i][j] = nr minim de orase dintr-un judet a.i. sa am j orase care nu-s inca fixe
//           intr-un judet; pentru orasele din subarborele curent din df din primii
//           i fii ai subarborelui

#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back

const int Inf = 0x3f3f3f, Nmax = 130;

vector<int> v[Nmax], vf[Nmax];
int a[Nmax][Nmax], b[Nmax][Nmax], t[Nmax], Fii[Nmax];
int N, K;

inline void Df(int x);

int main()
{ 
    freopen("judete.in","r",stdin);
    freopen("judete.out","w",stdout);
    scanf("%d%d",&N,&K);
    for (int i = 1, x, y; i < N; ++i)
    {
        scanf("%d%d", &x, &y);
        v[x].pb(y);
        v[y].pb(x);
    }

    memset(a, Inf, sizeof(a));
    Df(1);

    int sol = N + 1;
    for (int i = K; i <= N; ++i)
        if (a[1][i] <= N) 
			sol = min(sol, max(a[1][i], i));

    printf("%d\n", sol);
    fclose(stdin); fclose(stdout);
    return 0;
}

inline void Df(int x)
{
    for (const int& y : v[x])
        if( y != t[x] )
        {
            vf[x].pb(y);
            t[y] =x;
            Df(y);
            Fii[x] += Fii[y] + 1;
        }

    if( vf[x].size() == 0 ) // frunza
    { 
        a[x][1] = 1;
        return;
    }

    memset(b, Inf, sizeof(b));
    memcpy(b[0], a[vf[x][0]], sizeof(b[0])); // primul fiu

	int i, j, k;
    for (i = 1; i < vf[x].size(); ++i)
        for (j = 0; j <= Fii[x]; ++j)
            for (k = 0; k <= j; ++k)
                b[i][j] = min(b[i][j], max(b[i - 1][k], a[vf[x][i]][j - k]));

    --i; // ultimul fiu
    for (j = 1; j <= N; ++j)
        a[x][j] = max(b[i][j - 1], j );

    a[x][0] = a[x][K];
    for (j = K + 1; j <= N; ++j)
        a[x][0] = min(a[x][0], a[x][j]);
}
